﻿//#define debug

using System;
using System.Collections.Generic;
using System.Text;
using Jegbor;

namespace Jegbor
{
    public static class Iras
    {
        /// <summary>
        /// Egy adott cella körberajzolása és kitöltése
        /// </summary>
        /// <param name="CellaX"></param>
        /// <param name="CellaY"></param>
        /// <param name="Táblázat"></param>
        public static void WriteCell(int cx, int cy, Jegbor array)
    {
        string szakasz = "+-----------+";
        int dx= 5+12*cx;
        int dy= 2+2*cy;
        Console.SetCursorPosition(dx,dy);
        Console.Write(szakasz);
        Console.SetCursorPosition(dx, dy+1);
        string tmpcell = array.GetCell(cx, cy).GetFormatted();
        if (tmpcell.Length <= 11)
        {
            string cella;
            cella = "|" + tmpcell.PadRight(11, ' ') + "|";
            Console.Write(cella);

        }
        else
        {
            Console.ForegroundColor = ConsoleColor.Red;
            string cella = "|" + tmpcell.Substring(0, 11) + "|";
            Console.Write(cella);
            Console.ForegroundColor = ConsoleColor.Gray;
        }
        Console.SetCursorPosition(dx, dy+2);
        Console.Write(szakasz);
    }

        /// <summary>
        /// Aktuális cella tartalmának megjelenítése
        /// </summary>
        /// <param name="Táblázat"></param>
        public static void WriteCellText(Jegbor array)
        {
            Console.SetCursorPosition(0, 19);
            Console.BackgroundColor = ConsoleColor.Red;
            Console.WriteLine(array.CurrentCell.GetText());
            Console.ResetColor();
            Console.Write(">>");
            try
            {
                string input = Console.ReadLine();
                if ((input == "Q") || (input == "q"))
                {
                    Program.kilep = true;
                }
                else
                {
                    array.ExecuteCommand(input);
                }
            }
            catch (Exception ex)
            {
                //Hibaüzenetek pozícionálása
                Console.SetCursorPosition(2, 20);
                string space = "";
                while (space.Length < 80) space = space + " ";
                for (int j = 0; j < 2; j++)
                {
                    Console.WriteLine(space);
                }
                Console.SetCursorPosition(2, 20);            
                Console.WriteLine("Hiba a kifejezés kiértékelése közben:");
                Console.WriteLine(ex.Message);
                Console.WriteLine("Nyomjon Enter-t a folytatáshoz.");
                Console.ReadLine();
            }
        }

        /// <summary>
        /// Felhasználói felület kirajzolása, kezelése
        /// </summary>
        /// <param name="Táblázat"></param>
        public static void Plot(Jegbor array)
        {
            Console.Clear();
            Console.SetCursorPosition(0, 0);
            string line = "+----+-----------+-----------+-----------+-----------+-----------+";
            string fejlec = "|    |     A     |     B     |     C     |     D     |     E     |";
            Console.WriteLine(line);
            Console.WriteLine(fejlec);
            Console.WriteLine(line);
            
   
            for (int i = 0; i <= 7; i++)
            {
              //  Console.WriteLine(line);
                Console.WriteLine("|  {0} |", i + 1);
                Console.WriteLine(line);
                for (int j = 0; j <= 4; j++)
                {                                        
 
                   WriteCell(j,i,array); 
                   
                }               
                Console.WriteLine();
              //  Console.WriteLine(line);
            }
            
            // Aktuális cella kiemelése:

                    //Cellaszín beállítása
            Console.BackgroundColor = ConsoleColor.Green;

            WriteCell(array.CurrentX, array.CurrentY, array);
                    //Cellaszín visszaállítása
            Console.ResetColor();
           
        }
        
    }

    public class Program
    {
        public static bool kilep = false;

        static void Main(string[] args)
        {
            Jegbor maintable = new Jegbor();
            while (!kilep)
            {
                try
                {
                        maintable.EvaluateCells();
                        Iras.Plot(maintable);
                }
                catch (Exception ex)
                {
                    //Hibaüzenetek pozícionálása
                    Console.SetCursorPosition(2, 20);
                    string space = "";
                     while (space.Length < 80) space = space + " ";
                    for (int j = 0; j < 2; j++)
                    {
                        Console.WriteLine(space);
                    }
                    Console.SetCursorPosition(2, 20);
                    Console.WriteLine(ex.Message);
                    Console.ReadLine();
                    
                    Console.SetCursorPosition(2, 20);
                    space = "";
                    while (space.Length < 80) space = space + " ";
                    for (int j = 0; j < 2; j++)
                    {
                        Console.WriteLine(space);
                    }
                    Console.SetCursorPosition(2, 20);
                }
                Iras.WriteCellText(maintable);
            }
            Console.Clear();
            Console.SetCursorPosition(30,10);                  
            Console.Write("Viszontlátásra! ;)");
            Console.ReadLine();

        }
    }
}
